diff a/src/hotspot/share/gc/shenandoah/shenandoahRootProcessor.hpp b/src/hotspot/share/gc/shenandoah/shenandoahRootProcessor.hpp
--- a/src/hotspot/share/gc/shenandoah/shenandoahRootProcessor.hpp
+++ b/src/hotspot/share/gc/shenandoah/shenandoahRootProcessor.hpp
@@ -82,14 +82,22 @@
 public:
   ShenandoahJFRWeakRoot();
 };
 #endif // INCLUDE_JFR
 
+#if INCLUDE_TSAN
+class ShenandoahTSANWeakRoot : public ShenandoahWeakSerialRoot {
+public:
+  ShenandoahTSANWeakRoot();
+};
+#endif // INCLUDE_TSAN
+
 class ShenandoahSerialWeakRoots {
 private:
   JVMTI_ONLY(ShenandoahJVMTIWeakRoot _jvmti_weak_roots;)
   JFR_ONLY(ShenandoahJFRWeakRoot     _jfr_weak_roots;)
+  TSAN_ONLY(ShenandoahTSANWeakRoot   _tsan_weak_roots;)
 public:
   void weak_oops_do(BoolObjectClosure* is_alive, OopClosure* keep_alive, uint worker_id);
   void weak_oops_do(OopClosure* cl, uint worker_id);
 };
 
